import UIKit

// This object is a collection view datasource that will return colored cells with random text inside, sized by autolayout

public class DataSource: NSObject, UICollectionViewDataSource {
    
    private let totalCells = 150
    lazy private var values: [String] = {
        return (0...255).map {
            _ in
            switch arc4random_uniform(3) {
            case 0: return "Hello"
            case 1: return "Hello, \nGoodbye"
            default: return "Hello,\nGoodbye,\nHello Again!"
            }
        }
    }()
    
    public func numberOfSections(in collectionView: UICollectionView) -> Int {
        return 1
    }
    
    public func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return totalCells
    }
    
    public func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "cell", for: indexPath) as! TextCell
        let hue = CGFloat(indexPath.item) / 255
        cell.backgroundColor = UIColor(hue: hue, saturation: 1, brightness: 1, alpha: 1)
        cell.label.text = values[indexPath.item]
        print(#function)
        return cell
    }
}
